﻿using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using QRcare.API.Repositories;
using QRcare.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace QRcare.API.Controllers
{
    [ApiController]
    [Route("/patient")]
    public class PatientController : ControllerBase
    {
        private readonly IPatientRep patientRep;

        public PatientController(IPatientRep patientRep)
        {
            this.patientRep = patientRep;
        }

        [HttpGet("{patientId}")]
        public async Task<ActionResult<PatientPersonalProfile>> GetPatient (string patientId)
        {
            try
            {
                var result = await patientRep.GetPatient(patientId);
                if(result==null)
                {
                    return NotFound();
                }
                return result;
            }
            catch (Exception)
            {

                return BadRequest();
            }
        }
        [HttpPost("/Mobile")]
        public async Task<ActionResult<PatientPersonalProfile>> GetMobileePatient(UserLogin user)
        {
            try
            {
                var result = await patientRep.GetMobilePatient(user);
                if (result == null)
                {
                    return NotFound();
                }
                return result;
            }
            catch (Exception)
            {
                return BadRequest();
            }
        }
    }
}
