﻿using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using QRcare.API.Repositories;
using QRcare.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace QRcare.API.Controllers
{
    [ApiController]
    [Route("/diagnose")]
    public class PresentDiagnoseController : ControllerBase
    {
        private readonly IPresentDiagnoseRep presentDiagnoseRep;

        public PresentDiagnoseController(IPresentDiagnoseRep presentDiagnoseRep)
        {
            this.presentDiagnoseRep = presentDiagnoseRep;
        }

        [HttpGet("{patientId}")]
        public async Task<ActionResult<IEnumerable<PresentDiagnose>>> GetPatientDiagnoses (string patientId)
        {
            try
            {
                var result = await presentDiagnoseRep.GetPresentDiagnoses(patientId);
                if (result.Any())
                {
                    return Ok(result);
                }
                return NotFound();
            }
            catch (Exception)
            {
                return BadRequest();
            }
        }

        [HttpPost]

        public async Task CreatPresentDiagnose (PresentDiagnose presentDiagnose)
        {
            try
            {
                if(presentDiagnose is null)
                {
                     BadRequest();
                }
                await presentDiagnoseRep.CreatePresentDiagnose(presentDiagnose);

            }
            catch (Exception)
            {
                BadRequest();
            }
        }
    }
}
