﻿using Microsoft.EntityFrameworkCore.Migrations;

namespace QRcare.API.Migrations
{
    public partial class modifyqrcare : Migration
    {
        protected override void Up(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.AddColumn<string>(
                name: "Role",
                table: "UserLogins",
                type: "nvarchar(max)",
                nullable: false,
                defaultValue: "");

            migrationBuilder.AlterColumn<string>(
                name: "PresentIllness",
                table: "PresentDiagnoses",
                type: "nvarchar(max)",
                nullable: true,
                oldClrType: typeof(string),
                oldType: "nvarchar(max)");

            migrationBuilder.AlterColumn<string>(
                name: "PatientPersonalProfilePatientId",
                table: "PresentDiagnoses",
                type: "nvarchar(20)",
                nullable: false,
                oldClrType: typeof(string),
                oldType: "nvarchar(20)",
                oldComputedColumnSql: "[PatientPresentFK]");

            migrationBuilder.AlterColumn<string>(
                name: "MinimumAnamnesis",
                table: "PresentDiagnoses",
                type: "nvarchar(max)",
                nullable: true,
                oldClrType: typeof(string),
                oldType: "nvarchar(max)");

            migrationBuilder.AddColumn<string>(
                name: "CAVE",
                table: "PresentDiagnoses",
                type: "nvarchar(max)",
                nullable: true);

            migrationBuilder.AddColumn<string>(
                name: "Description",
                table: "PresentDiagnoses",
                type: "nvarchar(max)",
                nullable: true);

            migrationBuilder.UpdateData(
                table: "UserLogins",
                keyColumn: "UserId",
                keyValue: "100",
                column: "Role",
                value: "Doctor");
        }

        protected override void Down(MigrationBuilder migrationBuilder)
        {
            migrationBuilder.DropColumn(
                name: "Role",
                table: "UserLogins");

            migrationBuilder.DropColumn(
                name: "CAVE",
                table: "PresentDiagnoses");

            migrationBuilder.DropColumn(
                name: "Description",
                table: "PresentDiagnoses");

            migrationBuilder.AlterColumn<string>(
                name: "PresentIllness",
                table: "PresentDiagnoses",
                type: "nvarchar(max)",
                nullable: false,
                defaultValue: "",
                oldClrType: typeof(string),
                oldType: "nvarchar(max)",
                oldNullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "MinimumAnamnesis",
                table: "PresentDiagnoses",
                type: "nvarchar(max)",
                nullable: false,
                defaultValue: "",
                oldClrType: typeof(string),
                oldType: "nvarchar(max)",
                oldNullable: true);

            migrationBuilder.AlterColumn<string>(
                name: "PatientPersonalProfilePatientId",
                table: "PresentDiagnoses",
                type: "nvarchar(20)",
                nullable: false,
                computedColumnSql: "[PatientPresentFK]",
                oldClrType: typeof(string),
                oldType: "nvarchar(20)");
        }
    }
}
