﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using QRcare.API.Date;
using QRcare.Models;


namespace QRcare.API.Repositories
{
    public class AnamnesisRep : IAnamnesisRep
    {
        private readonly QRcareDbContext qrDbContext;
        public AnamnesisRep(QRcareDbContext qrDbContext)
        {
            this.qrDbContext = qrDbContext;
        }

        public async Task AddAnamnesis(Anamnesis anamnesis)
        {
            await qrDbContext.Anamnesis.AddAsync(anamnesis);
            await qrDbContext.SaveChangesAsync();
        }

        public async Task<Anamnesis> GetAnamnesis(string patientId)
        {
            return await qrDbContext.Anamnesis.FirstOrDefaultAsync(e => e.PatientAnamnesisFK == patientId);
        }

        public async Task UpdateAnamnesis(Anamnesis anamnesis)
        {
            var result = await qrDbContext.Anamnesis.FirstOrDefaultAsync(e => e.AnamnesisId == anamnesis.AnamnesisId);
                if (result != null)
            {
                result.AllergicAnamnesis = anamnesis.AllergicAnamnesis;
                result.FamilyAnamnesis = anamnesis.FamilyAnamnesis;
                result.GynecologicalAnamnesis = anamnesis.GynecologicalAnamnesis;
                result.PharmacologicalAnamnesis = anamnesis.PharmacologicalAnamnesis;
                result.SocialAnamnesis = anamnesis.SocialAnamnesis;
                result.ToxicologicalAndAbuseAnamnesis = anamnesis.ToxicologicalAndAbuseAnamnesis;
                result.WorkAnamnesis = anamnesis.WorkAnamnesis;
                await qrDbContext.SaveChangesAsync();
            }
        }
    }
}
