﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using QRcare.API.Date;
using QRcare.Models;


namespace QRcare.API.Repositories
{
    public class PatientRep : IPatientRep

    {
        private readonly QRcareDbContext qrcareDbContext;

        public PatientRep(QRcareDbContext qrcareDbContext)
        {
            this.qrcareDbContext = qrcareDbContext;
        }

        public async Task<PatientPersonalProfile> GetMobilePatient(UserLogin user)
        {
            
            var checkPassword = await qrcareDbContext.UserLogins.FirstOrDefaultAsync(e => e.UserName == user.UserName);
            if (checkPassword is not null && checkPassword.Password == user.Password)
            {
                return await qrcareDbContext.PatientPersonalProfiles.FirstOrDefaultAsync(e => e.PatientId == user.UserId);
            }
            return null;
        }

        public async Task<PatientPersonalProfile> GetPatient(string patientId)
        {
            var key = qrcareDbContext.QRCodeKeys.FirstOrDefault(e => e.PatientKeyId == patientId);
            if (key.QrKey is not null)
            {
                key.QrKey = null;
                await qrcareDbContext.SaveChangesAsync();
                return await qrcareDbContext.PatientPersonalProfiles.FirstOrDefaultAsync(e => e.PatientId == patientId);
            }
            return null;
        }
    }
}
