﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using QRcare.API.Date;
using QRcare.Models;


namespace QRcare.API.Repositories
{
    public class PresentDiagnoseRep : IPresentDiagnoseRep
    {
        private readonly QRcareDbContext qrcareDbContext;
        public PresentDiagnoseRep(QRcareDbContext qrcareDbContext)
        {
            this.qrcareDbContext = qrcareDbContext;
        }

        public async Task CreatePresentDiagnose(PresentDiagnose presentDiagnose)
        {
            int id;
            id = qrcareDbContext.PresentDiagnoses.CountAsync().Result;
            presentDiagnose.DiagnoseId = id++.ToString();
            await qrcareDbContext.PresentDiagnoses.AddAsync(presentDiagnose);
            await qrcareDbContext.SaveChangesAsync();
        }

        public async Task<IEnumerable<PresentDiagnose>> GetPresentDiagnoses(string patientId)
        {
            IQueryable<PresentDiagnose> diagnoses = qrcareDbContext.PresentDiagnoses;
            if(!string.IsNullOrEmpty(patientId))
            {
                diagnoses = diagnoses.Where(e => e.PatientPresentFK == patientId);
            }
            return await diagnoses.ToListAsync();
        }
    }
}
