﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.EntityFrameworkCore;
using QRcare.API.Date;
using QRcare.Models;
using QRcare.API.KeyGenerator;
using System.Text.Json;

namespace QRcare.API.Repositories
{
    public class QRKeyRep : IQRKeyRep
    {
        private readonly QRcareDbContext qrcareDbContext;

        public QRKeyRep(QRcareDbContext qrcareDbContext)
        {
            this.qrcareDbContext = qrcareDbContext;
        }

        public async Task<string> GetPatientId(string QRKey)
        {
            var result = await qrcareDbContext.QRCodeKeys.FirstOrDefaultAsync(e => e.QrKey == QRKey);
            if(result!=null)
            {
                return result.PatientKeyId;
            }
            return null;
        }

        public async Task<string> GetQRcodeKey(UserLogin user)
        {
            var checkPassword = await qrcareDbContext.UserLogins.FirstOrDefaultAsync(e => e.UserName == user.UserName);
            if (checkPassword is not null && checkPassword.Password == user.Password)
            {
                var result = await qrcareDbContext.QRCodeKeys.FirstOrDefaultAsync(e => e.PatientKeyId == user.UserId);
                if (result != null)
                {
                    string key = QRKeyGenerator.GetUniqueKey();
                    result.QrKey = key;
                    await qrcareDbContext.SaveChangesAsync();
                    string jsonKey = JsonSerializer.Serialize(key);
                    return jsonKey;
                }
                else
                    return null;
            }
            return null;
        }

        public async Task DeleteQRKey(string patientId)
        {
            var result = await qrcareDbContext.QRCodeKeys.FirstOrDefaultAsync(e => e.PatientKeyId == patientId);
            if (result != null)
            {
                result.QrKey = null;
                await qrcareDbContext.SaveChangesAsync();
            }
        }
    }
}
