﻿IF OBJECT_ID(N'[__EFMigrationsHistory]') IS NULL
BEGIN
    CREATE TABLE [__EFMigrationsHistory] (
        [MigrationId] nvarchar(150) NOT NULL,
        [ProductVersion] nvarchar(32) NOT NULL,
        CONSTRAINT [PK___EFMigrationsHistory] PRIMARY KEY ([MigrationId])
    );
END;
GO

BEGIN TRANSACTION;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    CREATE TABLE [PatientPersonalProfiles] (
        [PatientId] nvarchar(20) NOT NULL,
        [FirstName] nvarchar(50) NOT NULL,
        [LastName] nvarchar(50) NOT NULL,
        [DateOfBirht] datetime2 NOT NULL,
        [Gender] nvarchar(10) NOT NULL,
        [Email] nvarchar(50) NOT NULL,
        [PhoneNumber] nvarchar(20) NOT NULL,
        [InsuranceNumber] nvarchar(10) NOT NULL,
        [InsuranceKod] nvarchar(3) NOT NULL,
        CONSTRAINT [PK_PatientPersonalProfiles] PRIMARY KEY ([PatientId])
    );
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    CREATE TABLE [QRCodeKeys] (
        [PatientKeyId] nvarchar(20) NOT NULL,
        [QrKey] nvarchar(20) NULL,
        CONSTRAINT [PK_QRCodeKeys] PRIMARY KEY ([PatientKeyId])
    );
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    CREATE TABLE [UserLogins] (
        [UserId] nvarchar(20) NOT NULL,
        [UserName] nvarchar(50) NOT NULL,
        [Password] nvarchar(50) NOT NULL,
        CONSTRAINT [PK_UserLogins] PRIMARY KEY ([UserId])
    );
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    CREATE TABLE [Anamnesis] (
        [AnamnesisId] nvarchar(20) NOT NULL,
        [FamilyAnamnesis] nvarchar(max) NULL,
        [PharmacologicalAnamnesis] nvarchar(max) NULL,
        [ToxicologicalAndAbuseAnamnesis] nvarchar(max) NULL,
        [AllergicAnamnesis] nvarchar(max) NULL,
        [WorkAnamnesis] nvarchar(max) NULL,
        [SocialAnamnesis] nvarchar(max) NULL,
        [GynecologicalAnamnesis] nvarchar(max) NULL,
        [PatientAnamnesisFK] nvarchar(20) NULL,
        CONSTRAINT [PK_Anamnesis] PRIMARY KEY ([AnamnesisId]),
        CONSTRAINT [FK_Anamnesis_PatientPersonalProfiles_PatientAnamnesisFK] FOREIGN KEY ([PatientAnamnesisFK]) REFERENCES [PatientPersonalProfiles] ([PatientId]) ON DELETE NO ACTION
    );
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    CREATE TABLE [PresentDiagnoses] (
        [DiagnoseId] nvarchar(20) NOT NULL,
        [DiagnoseDate] datetime2 NOT NULL,
        [MinimumAnamnesis] nvarchar(max) NOT NULL,
        [PresentIllness] nvarchar(max) NOT NULL,
        [PatientPresentFK] nvarchar(20) NOT NULL,
        [PatientPersonalProfilePatientId] AS [PatientPresentFK],
        CONSTRAINT [PK_PresentDiagnoses] PRIMARY KEY ([DiagnoseId]),
        CONSTRAINT [FK_PresentDiagnoses_PatientPersonalProfiles_PatientPersonalProfilePatientId] FOREIGN KEY ([PatientPersonalProfilePatientId]) REFERENCES [PatientPersonalProfiles] ([PatientId]) ON DELETE CASCADE
    );
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    IF EXISTS (SELECT * FROM [sys].[identity_columns] WHERE [name] IN (N'PatientId', N'DateOfBirht', N'Email', N'FirstName', N'Gender', N'InsuranceKod', N'InsuranceNumber', N'LastName', N'PhoneNumber') AND [object_id] = OBJECT_ID(N'[PatientPersonalProfiles]'))
        SET IDENTITY_INSERT [PatientPersonalProfiles] ON;
    EXEC(N'INSERT INTO [PatientPersonalProfiles] ([PatientId], [DateOfBirht], [Email], [FirstName], [Gender], [InsuranceKod], [InsuranceNumber], [LastName], [PhoneNumber])
    VALUES (N''100'', ''1995-08-16T00:00:00.0000000'', N''zabadi@gmail.com'', N''Mohammad'', N''Male'', N''777'', N''3015558077'', N''Zabadi'', N''+470775421255'')');
    IF EXISTS (SELECT * FROM [sys].[identity_columns] WHERE [name] IN (N'PatientId', N'DateOfBirht', N'Email', N'FirstName', N'Gender', N'InsuranceKod', N'InsuranceNumber', N'LastName', N'PhoneNumber') AND [object_id] = OBJECT_ID(N'[PatientPersonalProfiles]'))
        SET IDENTITY_INSERT [PatientPersonalProfiles] OFF;
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    IF EXISTS (SELECT * FROM [sys].[identity_columns] WHERE [name] IN (N'PatientKeyId', N'QrKey') AND [object_id] = OBJECT_ID(N'[QRCodeKeys]'))
        SET IDENTITY_INSERT [QRCodeKeys] ON;
    EXEC(N'INSERT INTO [QRCodeKeys] ([PatientKeyId], [QrKey])
    VALUES (N''100'', N''12345'')');
    IF EXISTS (SELECT * FROM [sys].[identity_columns] WHERE [name] IN (N'PatientKeyId', N'QrKey') AND [object_id] = OBJECT_ID(N'[QRCodeKeys]'))
        SET IDENTITY_INSERT [QRCodeKeys] OFF;
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    IF EXISTS (SELECT * FROM [sys].[identity_columns] WHERE [name] IN (N'UserId', N'Password', N'UserName') AND [object_id] = OBJECT_ID(N'[UserLogins]'))
        SET IDENTITY_INSERT [UserLogins] ON;
    EXEC(N'INSERT INTO [UserLogins] ([UserId], [Password], [UserName])
    VALUES (N''100'', N''0000'', N''mohammad'')');
    IF EXISTS (SELECT * FROM [sys].[identity_columns] WHERE [name] IN (N'UserId', N'Password', N'UserName') AND [object_id] = OBJECT_ID(N'[UserLogins]'))
        SET IDENTITY_INSERT [UserLogins] OFF;
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    IF EXISTS (SELECT * FROM [sys].[identity_columns] WHERE [name] IN (N'AnamnesisId', N'AllergicAnamnesis', N'FamilyAnamnesis', N'GynecologicalAnamnesis', N'PatientAnamnesisFK', N'PharmacologicalAnamnesis', N'SocialAnamnesis', N'ToxicologicalAndAbuseAnamnesis', N'WorkAnamnesis') AND [object_id] = OBJECT_ID(N'[Anamnesis]'))
        SET IDENTITY_INSERT [Anamnesis] ON;
    EXEC(N'INSERT INTO [Anamnesis] ([AnamnesisId], [AllergicAnamnesis], [FamilyAnamnesis], [GynecologicalAnamnesis], [PatientAnamnesisFK], [PharmacologicalAnamnesis], [SocialAnamnesis], [ToxicologicalAndAbuseAnamnesis], [WorkAnamnesis])
    VALUES (N''1000'', N''none'', N''none'', N''none'', N''100'', N''none'', N''none'', N''none'', N''none'')');
    IF EXISTS (SELECT * FROM [sys].[identity_columns] WHERE [name] IN (N'AnamnesisId', N'AllergicAnamnesis', N'FamilyAnamnesis', N'GynecologicalAnamnesis', N'PatientAnamnesisFK', N'PharmacologicalAnamnesis', N'SocialAnamnesis', N'ToxicologicalAndAbuseAnamnesis', N'WorkAnamnesis') AND [object_id] = OBJECT_ID(N'[Anamnesis]'))
        SET IDENTITY_INSERT [Anamnesis] OFF;
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    EXEC(N'CREATE UNIQUE INDEX [IX_Anamnesis_PatientAnamnesisFK] ON [Anamnesis] ([PatientAnamnesisFK]) WHERE [PatientAnamnesisFK] IS NOT NULL');
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    CREATE INDEX [IX_PresentDiagnoses_PatientPersonalProfilePatientId] ON [PresentDiagnoses] ([PatientPersonalProfilePatientId]);
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20211223113733_initialQRcare')
BEGIN
    INSERT INTO [__EFMigrationsHistory] ([MigrationId], [ProductVersion])
    VALUES (N'20211223113733_initialQRcare', N'5.0.10');
END;
GO

COMMIT;
GO

BEGIN TRANSACTION;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220112183400_modifyqrcare')
BEGIN
    ALTER TABLE [UserLogins] ADD [Role] nvarchar(max) NOT NULL DEFAULT N'';
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220112183400_modifyqrcare')
BEGIN
    DECLARE @var0 sysname;
    SELECT @var0 = [d].[name]
    FROM [sys].[default_constraints] [d]
    INNER JOIN [sys].[columns] [c] ON [d].[parent_column_id] = [c].[column_id] AND [d].[parent_object_id] = [c].[object_id]
    WHERE ([d].[parent_object_id] = OBJECT_ID(N'[PresentDiagnoses]') AND [c].[name] = N'PresentIllness');
    IF @var0 IS NOT NULL EXEC(N'ALTER TABLE [PresentDiagnoses] DROP CONSTRAINT [' + @var0 + '];');
    ALTER TABLE [PresentDiagnoses] ALTER COLUMN [PresentIllness] nvarchar(max) NULL;
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220112183400_modifyqrcare')
BEGIN
    DECLARE @var1 sysname;
    SELECT @var1 = [d].[name]
    FROM [sys].[default_constraints] [d]
    INNER JOIN [sys].[columns] [c] ON [d].[parent_column_id] = [c].[column_id] AND [d].[parent_object_id] = [c].[object_id]
    WHERE ([d].[parent_object_id] = OBJECT_ID(N'[PresentDiagnoses]') AND [c].[name] = N'MinimumAnamnesis');
    IF @var1 IS NOT NULL EXEC(N'ALTER TABLE [PresentDiagnoses] DROP CONSTRAINT [' + @var1 + '];');
    ALTER TABLE [PresentDiagnoses] ALTER COLUMN [MinimumAnamnesis] nvarchar(max) NULL;
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220112183400_modifyqrcare')
BEGIN
    ALTER TABLE [PresentDiagnoses] ADD [CAVE] nvarchar(max) NULL;
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220112183400_modifyqrcare')
BEGIN
    ALTER TABLE [PresentDiagnoses] ADD [Description] nvarchar(max) NULL;
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220112183400_modifyqrcare')
BEGIN
    EXEC(N'UPDATE [UserLogins] SET [Role] = N''Doctor''
    WHERE [UserId] = N''100'';
    SELECT @@ROWCOUNT');
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220112183400_modifyqrcare')
BEGIN
    INSERT INTO [__EFMigrationsHistory] ([MigrationId], [ProductVersion])
    VALUES (N'20220112183400_modifyqrcare', N'5.0.10');
END;
GO

COMMIT;
GO

BEGIN TRANSACTION;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220113070857_fixRelation')
BEGIN
    ALTER TABLE [PresentDiagnoses] DROP CONSTRAINT [FK_PresentDiagnoses_PatientPersonalProfiles_PatientPersonalProfilePatientId];
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220113070857_fixRelation')
BEGIN
    DROP INDEX [IX_PresentDiagnoses_PatientPersonalProfilePatientId] ON [PresentDiagnoses];
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220113070857_fixRelation')
BEGIN
    DECLARE @var2 sysname;
    SELECT @var2 = [d].[name]
    FROM [sys].[default_constraints] [d]
    INNER JOIN [sys].[columns] [c] ON [d].[parent_column_id] = [c].[column_id] AND [d].[parent_object_id] = [c].[object_id]
    WHERE ([d].[parent_object_id] = OBJECT_ID(N'[PresentDiagnoses]') AND [c].[name] = N'PatientPersonalProfilePatientId');
    IF @var2 IS NOT NULL EXEC(N'ALTER TABLE [PresentDiagnoses] DROP CONSTRAINT [' + @var2 + '];');
    ALTER TABLE [PresentDiagnoses] DROP COLUMN [PatientPersonalProfilePatientId];
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220113070857_fixRelation')
BEGIN
    CREATE INDEX [IX_PresentDiagnoses_PatientPresentFK] ON [PresentDiagnoses] ([PatientPresentFK]);
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220113070857_fixRelation')
BEGIN
    ALTER TABLE [PresentDiagnoses] ADD CONSTRAINT [FK_PresentDiagnoses_PatientPersonalProfiles_PatientPresentFK] FOREIGN KEY ([PatientPresentFK]) REFERENCES [PatientPersonalProfiles] ([PatientId]) ON DELETE CASCADE;
END;
GO

IF NOT EXISTS(SELECT * FROM [__EFMigrationsHistory] WHERE [MigrationId] = N'20220113070857_fixRelation')
BEGIN
    INSERT INTO [__EFMigrationsHistory] ([MigrationId], [ProductVersion])
    VALUES (N'20220113070857_fixRelation', N'5.0.10');
END;
GO

COMMIT;
GO

