﻿using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using QRcare.Models;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;

namespace QRcare.Services
{
    public static class QRKeyService
    {
        static UserLogin userLogin = new UserLogin();

        static string BaseUrl = "https://qrcareapi.azurewebsites.net/";

        static HttpClient client;

        static QRKeyService()
        {
            client = new HttpClient
            {
                BaseAddress = new Uri(BaseUrl)
            }; 
        }

        public static async Task<string> GetQRKey(UserLogin user)
        {
            var json = JsonConvert.SerializeObject(user);
            var content = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PostAsync("/QRKey", content);
            if (response.IsSuccessStatusCode)
            {
                var result = await response.Content.ReadAsStringAsync();
                return JsonConvert.DeserializeObject<string>(result);
            }
            return null;
        }
        public static async Task DeleteQRKey(string Id)
        {
             await client.DeleteAsync($"/QRKey/{Id}");
        }
        public static async Task<UserModel> GetPatientProfile(UserLogin userLogin)
        {
            var json = JsonConvert.SerializeObject(userLogin);
            var content = new StringContent(json, Encoding.UTF8, "application/json");
            var response = await client.PostAsync("/mobile", content);
            JObject jsonresponse = JObject.Parse(response.Content.ReadAsStringAsync().Result);
            JToken token = jsonresponse;
            UserModel user = token.ToObject<UserModel>();
            return user;
        }
        public static async Task<UserLogin> Auth(string username,string password)
        {
            var userLogin = new UserLogin
            {
                UserId = "id",
                Role = "role",
                Password = password,
                UserName = username
            };
            var json = JsonConvert.SerializeObject(userLogin);
            var content = new StringContent(json, Encoding.UTF8, "application/json");
            HttpResponseMessage response = await client.PostAsync("/login",content);
            if (response.IsSuccessStatusCode)
            {
                var result = await response.Content.ReadAsStringAsync();
                return JsonConvert.DeserializeObject<UserLogin>(result);
            }
            return null;
        }
    }
}
