﻿using Plugin.Fingerprint;
using Plugin.Fingerprint.Abstractions;
using QRcare.Services;
using QRcare.Views;
using System;
using System.Windows.Input;
using Xamarin.Essentials;
using Xamarin.Forms;

namespace QRcare.ViewModels
{
    class HomeViewModel : BaseViewModel
    {
        public Command GeneretaCommand { get; }
        public Command GeneretaFingerprintCommand { get; }
        private string password;

        public HomeViewModel()
        {
            Title = "QRcare";
            GeneretaCommand = new Command(OnGenerateClicked);
            GeneretaFingerprintCommand = new Command(onGeneretaFingerprintCommand);
        }
        public string Password
        {
            get { return password; }
            set
            {
                SetProperty(ref password, value);
            }
        }
        private async void OnGenerateClicked(object obj)
        {
            var isAuth = await QRKeyService.Auth(Preferences.Get("Username", string.Empty), Password);
            if (isAuth != null)
            {
                await Shell.Current.GoToAsync($"//{nameof(QRCodePage)}");
            }
            else
            {
                await Application.Current.MainPage.DisplayAlert("Unauthorized", "Wrong Password, please try again.", "OK");
            }
        }

        private async void onGeneretaFingerprintCommand(object obj)
        {
            
            string user = Preferences.Get("Username", string.Empty);
            string password = Preferences.Get("Password", string.Empty);
            var available = await CrossFingerprint.Current.IsAvailableAsync();
            if (!available)
            {
                await Application.Current.MainPage.DisplayAlert("Error", "Fingerprint is not available, please login using password", "Cancel");
                return;
            }
            var authResult = await CrossFingerprint.Current.AuthenticateAsync
              (new AuthenticationRequestConfiguration("Fingerprint Login", "Do You want to authorize using Your Fingerprint?"));
            if (authResult.Authenticated)
            {
                var isAuth = await QRKeyService.Auth(user, password);
                if (isAuth != null)
                {
                    await Shell.Current.GoToAsync($"//{nameof(QRCodePage)}");
                }
                else
                {
                    await Application.Current.MainPage.DisplayAlert("Unauthorized", "The Password was changed, please login again", "OK");
                    await Shell.Current.GoToAsync("//LoginPage");
                }
            }
            else
            {
                await Application.Current.MainPage.DisplayAlert("Unauthorized", "Fingerprint is not recognised, please try again", "OK");
                return;
            }
        }
    }
}
