﻿using Newtonsoft.Json;
using QRcare.Services;
using QRcare.Views;
using System;
using System.Collections.Generic;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace QRcare.ViewModels
{
    public class QRCodeViewModel : BaseViewModel
    {
        public Command CloseCommand { get; }
        public string key;


        public QRCodeViewModel()
        {
            Title = "QR key";
            CloseCommand = new Command(OnCloseClicked);
        }
        public string Key
        {
            get { return key; }
            set
            {
                SetProperty(ref key, value);
            }
        }
        public async void LoadQRKey()
        {
            Key = await QRKeyService.GetQRKey(DataStore.GetUser().Result);
        }
        public void OnAppearing()
        {
            LoadQRKey();
        }
        private async void OnCloseClicked()
        {
            await QRKeyService.DeleteQRKey(DataStore.GetUserId().Result);
            await Shell.Current.GoToAsync($"//{nameof(HomePage)}");
        }

    }
}
