﻿using BlazorBarcodeScanner.ZXing.JS;
using Microsoft.AspNetCore.Components;
using Microsoft.AspNetCore.Components.Web;
using QRcare.Models;
using QRcare.WebApp.Serviceses;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace QRcare.WebApp.Pages
{
    public class QRScanPageBase : ComponentBase
    {
        [Inject]
        public IQRKeySer QRKey { get; set; }
        [Inject]
        NavigationManager NavigationManager { get; set; }
        public string Key { get; set; } = string.Empty;

        public async Task ReadQRKey()
        {
           string id=  await QRKey.GetPatientId(Key);
           NavigationManager.NavigateTo($"/patient/{id}");

        }

        public BarcodeReader Reader=new BarcodeReader();
        public void OpenCamera(MouseEventArgs args)
        {
            if (Reader.IsDecoding)
                Reader.StopDecoding();
            else
                Reader.StartDecoding();
            //StateHasChanged();
        }

        public void LocalReceivedBarcodeText(BarcodeReceivedEventArgs args)
        {
            Key = args.BarcodeText;
            Reader.StopDecoding();
            Reader.Dispose();
            StateHasChanged();
        }

    }
}
