using Microsoft.AspNetCore.Components.WebAssembly.Hosting;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.AspNetCore.Components.Authorization;
using Microsoft.Extensions.Logging;
using QRcare.WebApp.Serviceses;
using System;
using System.Collections.Generic;
using System.Net.Http;
using System.Text;
using System.Threading.Tasks;
using QRcare.WebApp.Authentication;
using Syncfusion.Blazor;

namespace QRcare.WebApp
{
    public class Program
    {
        public static async Task Main(string[] args)
        {
            var builder = WebAssemblyHostBuilder.CreateDefault(args);
            builder.RootComponents.Add<App>("#app");
            builder.Services.AddHttpClient<IAnamnesisSer, AnamnesisSer>(client =>
            {
                client.BaseAddress = new Uri("https://qrcareapi.azurewebsites.net/");
            });
            builder.Services.AddHttpClient<IPatientSer, PatientSer>(client =>
            {
                client.BaseAddress = new Uri("https://qrcareapi.azurewebsites.net/");
            });
            builder.Services.AddHttpClient<IPresentDiagnoseSer, PresentDiagnoseSer>(client =>
            {
                client.BaseAddress = new Uri("https://qrcareapi.azurewebsites.net/");
            });
            builder.Services.AddHttpClient<ILoginSer, LoginSer>(client =>
            {
                client.BaseAddress = new Uri("https://qrcareapi.azurewebsites.net/");
            });
            builder.Services.AddHttpClient<IQRKeySer, QRKeySer>(client =>
            {
                client.BaseAddress = new Uri("https://qrcareapi.azurewebsites.net/");
            });
            //builder.Services.AddScoped(sp => new HttpClient { BaseAddress = new Uri(builder.HostEnvironment.BaseAddress) });
            //auth section **********************
            builder.Services.AddScoped<AuthenticationStateProvider, QRAuthStateProvider>();
            builder.Services.AddOptions();
            builder.Services.AddAuthorizationCore();
            //****************************
            builder.Services.AddOidcAuthentication(options =>
            {
                // Configure your authentication provider options here.
                // For more information, see https://aka.ms/blazor-standalone-auth
                builder.Configuration.Bind("Local", options.ProviderOptions);
            });

            builder.Services.AddSyncfusionBlazor();
            await builder.Build().RunAsync();
        }
    }
}
