﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Json;
using System.Threading.Tasks;
using QRcare.Models;


namespace QRcare.WebApp.Serviceses
{
    public class AnamnesisSer : IAnamnesisSer
    {
        private readonly HttpClient httpClient;
        public AnamnesisSer(HttpClient httpClient)
        {
            this.httpClient = httpClient;
        }
        public async Task<Anamnesis> GetAnamnesis(string patientId)
        {
            return await httpClient.GetFromJsonAsync<Anamnesis>($"anamnesis/{patientId}");
        }

        public async Task UpdateAnamnesis(Anamnesis anamnesis)
        {
            await httpClient.PutAsJsonAsync("anamnesis", anamnesis);
        }
    }
}
